Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Definition sym_eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) case_O (match_nat_type (return_type) case_O case_S O) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Parameter minus : nat -> nat -> nat.
Parameter minus_body : nat -> nat -> nat.
Axiom axiom_minus : forall (n:nat), connectives.equal (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n).
Definition eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((axiom_minus) (n)).
Definition sym_eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) minus_body n) (minus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((eq_minus) (n)).
Axiom axiom_minus_body_O : connectives.equal (nat -> nat) (minus_body O) (fun (m:nat) => O).
Definition eq_minus_body_O : leibniz.leibniz (nat -> nat) (minus_body O) (fun (m:nat) => O) := ((((connectives.equal_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (axiom_minus_body_O).
Definition sym_eq_minus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => O) (minus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (eq_minus_body_O).
Axiom axiom_minus_body_S : forall (n:nat), connectives.equal (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m).
Definition eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((axiom_minus_body_S) (n)).
Definition sym_eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) (minus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((eq_minus_body_S) (n)).
Definition nat_elim2 : forall (R:(nat -> nat -> Prop)), (forall (n:nat), R O n) -> (forall (n:nat), R (S n) O) -> (forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) -> forall (n:nat), forall (m:nat), R n m := fun (R:nat -> nat -> Prop) => fun (ROn:forall (n:nat), R O n) => (fun (RSO:forall (n:nat), R (S n) O) => (fun (RSS:forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) => (fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), R _x_365 m)) (fun (m:nat) => (ROn) (m))) (fun (n0:nat) => fun (Rn0m:forall (m:nat), R n0 m) => (fun (m:nat) => ((((match_nat_prop) (fun (__:nat) => R (S n0) __)) ((RSO) (n0))) (fun (auto:nat) => (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
Definition minus_O_n : forall (n:nat), logic.eq (nat) O (minus O n) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) O (minus O __))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (fun (auto:nat) => ((logic.refl) (nat)) (O)))))) (n).
Definition minus_n_O : forall (n:nat), logic.eq (nat) n (minus n O) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) __ (minus __ O))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (minus O O)) ((minus_O_n) (O)))) (fun (auto:nat) => (((sym_eq_minus) (S auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((sym_eq_minus_body_S) (auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((((sym_eq_match_nat_type_O) (nat)) (S auto)) (fun (q:nat) => minus auto q)) (fun (y:nat) => logic.eq (nat) (S auto) y)) (((logic.refl) (nat)) (S auto))))))) (n).
Definition eq_minus_S_pred : forall (n:nat), forall (m:nat), logic.eq (nat) (minus n (S m)) (pred (minus n m)) := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => logic.eq (nat) (minus __ (S _0)) (pred (minus __ _0)))) (fun (_n:nat) => (((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus O (S _n)) (pred (y _n)))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (y (S _n)) (pred (filter_nat_type (nat -> nat) minus_body O _n)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (y (S _n)) (pred (filter_nat_type (nat -> nat) minus_body O _n)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus_body O (S _n)) (pred (y _n)))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (minus_body O (S _n)) (pred (y _n)))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (y (S _n)) (match_nat_type (nat) O (fun (p:nat) => p) O))) ((((((sym_eq_match_nat_type_O) (nat)) (O)) (fun (p:nat) => p)) (fun (y:nat) => logic.eq (nat) O y)) (((logic.refl) (nat)) (O)))))))))) (fun (n:nat) => (((sym_eq_minus) (S n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S O)) (pred (y O)))) ((((sym_eq_minus) (S n)) (fun (y:(nat -> nat)) => logic.eq (nat) (y (S O)) (pred (filter_nat_type (nat -> nat) minus_body (S n) O)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (y (S O)) (pred (filter_nat_type (nat -> nat) minus_body (S n) O)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus_body (S n) (S O)) (pred (y O)))) ((((sym_eq_minus_body_S) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus_body (S n) (S O)) (pred (y O)))) ((((sym_eq_minus_body_S) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (y (S O)) (pred (match_nat_type (nat) (S n) (fun (q:nat) => minus n q) O)))) (((((((sym_eq_match_nat_type_S) (nat)) (S n)) (fun (q:nat) => minus n q)) (O)) (fun (y:nat) => logic.eq (nat) y (match_nat_type (nat) O (fun (p:nat) => p) (match_nat_type (nat) (S n) (fun (q:nat) => minus n q) O)))) ((((((sym_eq_match_nat_type_O) (nat)) (S n)) (fun (q:nat) => minus n q)) (fun (y:nat) => logic.eq (nat) (minus n O) (match_nat_type (nat) O (fun (p:nat) => p) y))) (((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (q:nat) => q)) (n)) (fun (y:nat) => logic.eq (nat) (minus n O) y)) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (nat) __ n)) (((logic.refl) (nat)) (n))) (minus n O)) ((minus_n_O) (n))))))))))))) (fun (n:nat) => fun (m:nat) => (((sym_eq_minus) (S n)) (fun (y:(nat -> nat)) => (logic.eq (nat) (minus n (S m)) (pred (minus n m))) -> logic.eq (nat) (minus (S n) (S (S m))) (pred (y (S m))))) ((((sym_eq_minus) (S n)) (fun (y:(nat -> nat)) => (logic.eq (nat) (minus n (S m)) (pred (minus n m))) -> logic.eq (nat) (y (S (S m))) (pred (filter_nat_type (nat -> nat) minus_body (S n) (S m))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (n)) (fun (y:(nat -> nat)) => (logic.eq (nat) (minus n (S m)) (pred (minus n m))) -> logic.eq (nat) (y (S (S m))) (pred (filter_nat_type (nat -> nat) minus_body (S n) (S m))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (n)) (fun (y:(nat -> nat)) => (logic.eq (nat) (minus n (S m)) (pred (minus n m))) -> logic.eq (nat) (minus_body (S n) (S (S m))) (pred (y (S m))))) ((((sym_eq_minus_body_S) (n)) (fun (y:(nat -> nat)) => (logic.eq (nat) (minus n (S m)) (pred (minus n m))) -> logic.eq (nat) (minus_body (S n) (S (S m))) (pred (y (S m))))) ((((sym_eq_minus_body_S) (n)) (fun (y:(nat -> nat)) => (logic.eq (nat) (minus n (S m)) (pred (minus n m))) -> logic.eq (nat) (y (S (S m))) (pred (match_nat_type (nat) (S n) (fun (q:nat) => minus n q) (S m))))) (((((((sym_eq_match_nat_type_S) (nat)) (S n)) (fun (q:nat) => minus n q)) (S m)) (fun (y:nat) => (logic.eq (nat) (minus n (S m)) (pred (minus n m))) -> logic.eq (nat) y (match_nat_type (nat) O (fun (p:nat) => p) (match_nat_type (nat) (S n) (fun (q:nat) => minus n q) (S m))))) (((((((sym_eq_match_nat_type_S) (nat)) (S n)) (fun (q:nat) => minus n q)) (m)) (fun (y:nat) => (logic.eq (nat) (minus n (S m)) (pred (minus n m))) -> logic.eq (nat) (minus n (S m)) (match_nat_type (nat) O (fun (p:nat) => p) y))) (fun (auto:logic.eq (nat) (minus n (S m)) (match_nat_type (nat) O (fun (p:nat) => p) (minus n m))) => (((((((logic.rewrite_r) (nat)) (match_nat_type (nat) O (fun (p:nat) => p) (minus n m))) (fun (__:nat) => logic.eq (nat) __ (match_nat_type (nat) O (fun (p:nat) => p) (minus n m)))) (((logic.refl) (nat)) (match_nat_type (nat) O (fun (p:nat) => p) (minus n m)))) (minus n (S m))) (auto))))))))))).
